/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package com.fixisoft.fix.example.ctrader.client;


import com.fixisoft.interfaces.fix.ConnectionType;
import com.fixisoft.fix.FixClientFactory;
import com.fixisoft.interfaces.fix.IFixClient;
import com.fixisoft.interfaces.fix.Protocol;
import com.fixisoft.interfaces.fix.config.IFixConfig;

import java.util.Map;

import static java.util.Map.entry;
import static java.util.Map.ofEntries;

public final class CTraderMDClientExample {

    public static final String CTRADER_CLIENT = "demo.ctrader.4545880";
    public static final String CTRADER_SERVER = "cServer";


    public static void main(String[] args)  {
        final String name = CTraderMDClientExample.class.getSimpleName();
        final IFixClient fixClient = FixClientFactory.makeClient(makeSimpleClientConfig(name), name,new CTraderClientIncomingHandler(), new CTraderMessageInitializer());
        fixClient.run();
    }

    public static IFixConfig makeSimpleClientConfig(final String name) {
        return FixClientFactory.loadConfig(name, ofEntries(
                entry(IFixConfig.BEGIN_STRING, "FIX.4.4"),
                entry(IFixConfig.CONNECTION_TYPE, ConnectionType.INITIATOR),
                entry(IFixConfig.DATA_DICTIONARY, "FIX44-CSERVER.xml"),
                entry(IFixConfig.START_TIME, "00:00:00"),
                entry(IFixConfig.END_TIME, "23:59:59"),
                entry(IFixConfig.TIME_ZONE, "Europe/Paris"),
                entry(IFixConfig.FILE_STORE_PATH, "./messages/" + name),
                entry(IFixConfig.HEART_BT_INT, 30),
                entry(IFixConfig.RESET_ON_LOGON, true),
                entry(IFixConfig.INCOMING_POOL_SIZES, Map.of(
                        "W", 1024,
                        "0", 64,
                        "1", 64,
                        "2", 64,
                        "3", 64,
                        "4", 64,
                        "5", 64,
                        "A", 64
                )),
                entry(IFixConfig.OUTGOING_POOL_SIZES, Map.of(
                        "V", 512,
                        "0", 64,
                        "1", 64,
                        "2", 64,
                        "3", 64,
                        "4", 64,
                        "5", 64,
                        "A", 64
                )),
                entry(IFixConfig.SENDER_COMP_ID, CTRADER_CLIENT),
                entry(IFixConfig.TARGET_COMP_ID, CTRADER_SERVER),
                entry(IFixConfig.SOCKET_CONNECT_PROTOCOL, Protocol.TCP.name()),
                entry(IFixConfig.SOCKET_HOST, "ctrader_server_hostname"),
                entry(IFixConfig.SOCKET_PORT, 5201)));
    }
}
