/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package com.fixisoft.fix.example.client;


import com.fixisoft.fix.FixClientFactory;
import com.fixisoft.interfaces.fix.ConnectionType;
import com.fixisoft.interfaces.fix.IFixClient;
import com.fixisoft.interfaces.fix.Protocol;
import com.fixisoft.interfaces.fix.config.IFixConfig;
import com.fixisoft.interfaces.fix.session.NoopMessageInitializer;

import java.util.Map;

import static java.util.Map.entry;
import static java.util.Map.ofEntries;

public final class FixMDClientExample {

    public static final String TEST_CLIENT_1 = "testClient_1";
    public static final String TEST_SERVER_1 = "testServer_1";


    public static void main(String[] args)  {
        final String name = FixMDClientExample.class.getSimpleName();
        final IFixClient fixClient = FixClientFactory.makeClient(makeSimpleClientConfig(name), name,new MDClientIncomingHandler(), new NoopMessageInitializer());
        fixClient.run();
    }

    public static IFixConfig makeSimpleClientConfig(final String name) {
        return FixClientFactory.loadConfig(name, ofEntries(
                entry(IFixConfig.BEGIN_STRING, "FIX.4.4"),
                entry(IFixConfig.CONNECTION_TYPE, ConnectionType.INITIATOR),
                entry(IFixConfig.DATA_DICTIONARY, "SIMPLE_MD.xml"),
                entry(IFixConfig.START_TIME, "00:00:00"),
                entry(IFixConfig.END_TIME, "23:59:59"),
                entry(IFixConfig.TIME_ZONE, "Europe/Paris"),
                entry(IFixConfig.FILE_STORE_PATH, "./messages/" + name),
                entry(IFixConfig.HEART_BT_INT, 10),
                entry(IFixConfig.SENDER_COMP_ID, TEST_CLIENT_1),
                entry(IFixConfig.TARGET_COMP_ID, TEST_SERVER_1),
                entry(IFixConfig.SOCKET_CONNECT_PROTOCOL, Protocol.TCP.name()),
                entry(IFixConfig.SOCKET_HOST, "localhost"),
                entry(IFixConfig.SOCKET_PORT, 8080)));
    }
}
